org.springframework.web.bind

## Class MissingPathVariableException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - javax.servlet.ServletException
      - - org.springframework.web.util.NestedServletException
        - - org.springframework.web.bind.ServletRequestBindingException
          - - org.springframework.web.bind.MissingRequestValueException
            - - org.springframework.web.bind.MissingPathVariableException

- All Implemented Interfaces:
    Serializable

      public class MissingPathVariableException
      extends MissingRequestValueException

  `ServletRequestBindingException` subclass that indicates that a path variable expected in the method parameters of an `@RequestMapping` method is not present among the URI variables extracted from the URL. Typically that means the URI template does not match the path variable name declared on the method parameter.
  Since:
    4.2
  Author:
    Rossen Stoyanchev
  See Also:
    `MissingMatrixVariableException`, Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MissingPathVariableException(String variableName, MethodParameter parameter)` Constructor for MissingPathVariableException.
    `MissingPathVariableException(String variableName, MethodParameter parameter, boolean missingAfterConversion)` Constructor for use when a value was present but converted to `null`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getMessage()` Return the detail message, including the message from the nested exception if there is one.
    `MethodParameter` | `getParameter()` Return the method parameter bound to the path variable.
    `String` | `getVariableName()` Return the expected name of the path variable.

    - ### Methods inherited from class org.springframework.web.bind.MissingRequestValueException

      `isMissingAfterConversion`

    - ### Methods inherited from class javax.servlet.ServletException

      `getRootCause`

    - ### Methods inherited from class java.lang.Throwable

      `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MissingPathVariableException

          public MissingPathVariableException(String variableName,
                                              MethodParameter parameter)

      Constructor for MissingPathVariableException.
      Parameters:
        `variableName` - the name of the missing path variable
        `parameter` - the method parameter

    - #### MissingPathVariableException

          public MissingPathVariableException(String variableName,
                                              MethodParameter parameter,
                                              boolean missingAfterConversion)

      Constructor for use when a value was present but converted to `null`.
      Parameters:
        `variableName` - the name of the missing path variable
        `parameter` - the method parameter
        `missingAfterConversion` - whether the value became null after conversion
      Since:
        5.3.6

  - ### Method Detail

    - #### getMessage

          public String getMessage()

      Description copied from class: `NestedServletException`
      Return the detail message, including the message from the nested exception if there is one.
      Overrides:
        `getMessage` in class `NestedServletException`

    - #### getVariableName

          public final String getVariableName()

      Return the expected name of the path variable.

    - #### getParameter

          public final MethodParameter getParameter()

      Return the method parameter bound to the path variable.